// Generated by LiveScript 1.5.0
(function(){
  var child_process, getAllEntries, ref$, map, sortBy, sortWith, reverse, markdown, deltosHome, readConfig, isIn, tagged, getFilename, getUrl, philtre, width, exec, fs, blocks, getChildEntries, buildListPage, buildImageListPage, toDatedMarkdownLink, toMarkdownLink, toImageBlock, sortOrderThenDate, buildHierarchicalList, embedWrapper, deltosLinkToHtml, processBlock, renderBlock, out$ = typeof exports != 'undefined' && exports || this;
  child_process = require('child_process');
  getAllEntries = require('./entries').getAllEntries;
  ref$ = require('prelude-ls'), map = ref$.map, sortBy = ref$.sortBy, sortWith = ref$.sortWith, reverse = ref$.reverse;
  ref$ = require('./util'), markdown = ref$.markdown, deltosHome = ref$.deltosHome, readConfig = ref$.readConfig, isIn = ref$.isIn, tagged = ref$.tagged, getFilename = ref$.getFilename, getUrl = ref$.getUrl;
  philtre = require('philtre').philtre;
  width = readConfig().width || 500;
  exec = require('child_process').execSync;
  fs = require('fs-extra');
  blocks = {};
  blocks.img = function(block, entry, big){
    var words, imgSrc, srcFile, fname, ref$, ftype, thumbroot, bigSrc, tag, caption, croppedHeader, cls;
    big == null && (big = false);
    words = block.split(' ');
    words.shift();
    imgSrc = words.shift().trim();
    srcFile = getFilename(entry.id) + '/' + imgSrc;
    fname = (ref$ = imgSrc.split('/'))[ref$.length - 1];
    ftype = (ref$ = imgSrc.split('.'))[ref$.length - 1];
    thumbroot = getFilename(entry.id) + '/img/';
    imgSrc = "/by-id/" + entry.id + "/img/" + fname + ".l." + ftype;
    bigSrc = "/by-id/" + entry.id + "/" + fname;
    if (big) {
      imgSrc = bigSrc;
    }
    if (!fs.existsSync(thumbroot + fname + '.l.' + ftype)) {
      fs.mkdirp(thumbroot);
      exec("convert \"" + srcFile + "\" -resize " + width + "x1000 " + thumbroot + "/" + fname + ".l." + ftype);
    }
    tag = "<a href=\"" + bigSrc + "\"><img src=\"" + imgSrc + "\"/></a>";
    caption = words.length ? '<p class="caption">' + markdown(words.join(' ')).substr(3) : '';
    if (!entry.firstImage) {
      croppedHeader = thumbroot + "/" + fname + ".c." + ftype;
      if (!fs.existsSync(croppedHeader)) {
        exec("convert \"" + srcFile + "\" -resize '" + width + "x200^' -gravity center -extent " + width + "x200 " + thumbroot + "/" + fname + ".c." + ftype);
        exec("convert \"" + srcFile + "\" -resize '90x90^' -gravity center -crop 90x90+0+0 " + thumbroot + "/" + fname + ".s." + ftype);
      }
      entry.firstImage = "/by-id/" + entry.id + "/" + fname;
    }
    cls = 'img';
    if (big) {
      cls += ' big-img';
    }
    return ("<div class=\"" + cls + "\">") + tag + caption + "</div>";
  };
  blocks['img-big'] = function(block, entry){
    return blocks.img(block, entry, true);
  };
  blocks.video = function(block, entry){
    var words, vidTag, caption;
    words = block.split(' ');
    words.shift();
    vidTag = "<video preload=\"auto\" autoplay=\"autoplay\" loop=\"loop\" style=\"width: 100%; height: auto;\" controls> <source src=\"" + words.shift() + "\" type='video/webm; codecs=\"vp8, vorbis\"'></source> </video>";
    caption = words.length ? '<p class="caption">' + words.join(' ') + '</p>' : '';
    return "<div class=\"img\">" + vidTag + caption + "</div>";
  };
  blocks.archive = function(block, entry){
    var entries, words, query;
    entry.updated = true;
    entries = getAllEntries();
    words = block.split(' ');
    if (words.length > 1) {
      words.shift();
      query = words.join(' ');
      entries = philtre(query, entries);
    }
    return buildListPage(entries, toMarkdownLink).join("\n");
  };
  blocks.children = function(block, entry){
    return buildListPage(getChildEntries(entry)).join("\n");
  };
  getChildEntries = function(parent){
    return getAllEntries().filter(function(it){
      var ref$;
      return -1 !== ((ref$ = parent.children) != null ? ref$.indexOf(it.id) : void 8);
    });
  };
  blocks.recent = function(block, entry, listBuilder){
    var entries, words, query;
    listBuilder == null && (listBuilder = buildImageListPage);
    entry.updated = true;
    entries = getAllEntries();
    words = block.split(' ');
    if (words.length > 1) {
      words.shift();
      query = words.join(' ');
      entries = philtre(query, entries);
    }
    return listBuilder(entries).slice(0, 5).join("\n");
  };
  blocks['recent-text'] = function(block, entry){
    return blocks.recent(block, entry, buildListPage);
  };
  buildListPage = function(entries, linker){
    var this$ = this;
    linker == null && (linker = toMarkdownLink);
    if (!entries) {
      entries = getAllEntries();
    }
    entries = entries.filter(tagged('published')).filter(function(it){
      return !tagged('hidden', it);
    });
    return map(linker)(
    reverse(
    sortBy(function(it){
      return it.date;
    }, entries)));
  };
  buildImageListPage = function(entries){
    return buildListPage(entries, toImageBlock);
  };
  toDatedMarkdownLink = function(it){
    var tags, day;
    tags = it.tags.filter(function(it){
      return it !== 'published';
    }).join(", ");
    day = "<span class=\"date\">" + it.date.substr(0, 10) + "</span>";
    return "- " + day + " - [" + it.title + "](" + getUrl(it) + ")";
  };
  toMarkdownLink = function(it){
    return "- [" + it.title + "](" + getUrl(it) + ")";
  };
  toImageBlock = function(it){
    var out;
    out = "<a href=\"" + getUrl(it) + "\">";
    out += '<div class="img img-block">';
    if (it.firstImage) {
      out += "<img src=\"" + it.firstImage + "\">";
    }
    out += "<div class=\"text-overlay\">" + it.title + "</div>";
    out += "</div></a>";
    return out;
  };
  sortOrderThenDate = function(a, b){
    if ((a != null && a.order) && (b != null && b.order)) {
      if (a.order < b.order) {
        return 1;
      } else {
        return -1;
      }
    }
    if (a.date > b.date) {
      return -1;
    } else {
      return 1;
    }
  };
  buildHierarchicalList = function(entries, depth, parent){
    var children, out, spacer, i$, len$, child;
    parent == null && (parent = null);
    if (depth === 0) {
      return '';
    }
    if (parent) {
      children = entries.filter(function(it){
        return it.parents && isIn(it.parents, parent);
      });
    } else {
      children = entries.filter(function(it){
        return !it.parents;
      });
    }
    children = sortWith(sortOrderThenDate, children);
    out = '';
    spacer = parent ? '  ' : '';
    for (i$ = 0, len$ = children.length; i$ < len$; ++i$) {
      child = children[i$];
      out += spacer + toMarkdownLink(child) + "\n";
      if (depth > 0) {
        out += buildHierarchicalList(entries, depth - 1, child.id).split("\n").map(fn$).join('\n');
      }
    }
    return out;
    function fn$(it){
      return spacer + it;
    }
  };
  embedWrapper = function(it){
    return "<div class=\"embed-content\">\n\n" + it + "\n\n</div>";
  };
  blocks.embed = function(block, entry){
    var lines, url, result, fname, rawFile;
    lines = block.split("\n");
    if (lines.length > 1) {
      return embedWrapper(lines.slice(1).join('\n'));
    }
    url = lines[0].split(' ').slice(1).join(' ');
    result = child_process.execSync("OEMBED_WIDTH=" + width + " kinkan '" + url + "'");
    fname = getFilename(entry.id + '/deltos');
    rawFile = fs.readFileSync(fname, 'utf-8');
    rawFile = rawFile.split(lines[0]).join(lines[0] + "\n" + result);
    fs.writeFileSync(fname, rawFile, 'utf-8');
    return embedWrapper(result);
  };
  blocks.html = function(block, entry){
    var words;
    words = block.trim().split(' ');
    words.shift();
    return embedWrapper(fs.readFileSync(getFilename(entry.id) + '/' + words[0]));
  };
  blocks['class'] = function(block, entry){
    var style, body, out;
    style = block.split("\n")[0].split(' ')[1];
    body = block.split("\n").slice(1).join("\n");
    return out = ("<p class=\"" + style + "\">") + markdown(deltosLinkToHtml(body)).slice(3);
  };
  deltosLinkToHtml = function(it){
    var linkRegex, entries;
    linkRegex = /\.\(([^\/]*)\/\/([^\)]*)\)/g;
    entries = getAllEntries();
    return it.replace(linkRegex, function(matched, label, dest){
      var entry;
      entry = entries.filter(function(it){
        return it.id === dest;
      })[0];
      return "<a href=\"" + getUrl(entry) + "\">" + label + "</a>";
    });
  };
  processBlock = function(keyword, block, entry){
    var e;
    try {
      return blocks[keyword](block, entry);
    } catch (e$) {
      e = e$;
      console.log("keyword: " + keyword);
      throw e;
    }
  };
  out$.renderBlock = renderBlock = function(block, entry){
    var keyword;
    while (block[0] === "\n") {
      block = block.substr(1);
    }
    if (block[0] === '!') {
      block = block.slice(1);
      keyword = block.split("\n")[0].split(' ')[0];
      return processBlock(keyword, block, entry);
    } else {
      return deltosLinkToHtml(block);
    }
  };
}).call(this);
