// Generated by LiveScript 1.5.0
(function(){
  var ref$, launchEditor, deltosHome, getFilename, readConfig, editConfig, installTheme, readEntry, newNote, dumpTodos, grepEntries, philtreEntries, dbInit, dbUpdate, dbDump, getThread, getThreadNext, getThreadPrev, getThreadLatest, dumpTsv, commands, addCommand, func, e;
  ref$ = require('./util'), launchEditor = ref$.launchEditor, deltosHome = ref$.deltosHome, getFilename = ref$.getFilename, readConfig = ref$.readConfig, editConfig = ref$.editConfig, installTheme = ref$.installTheme;
  ref$ = require('./entries'), readEntry = ref$.readEntry, newNote = ref$.newNote, dumpTodos = ref$.dumpTodos, grepEntries = ref$.grepEntries, philtreEntries = ref$.philtreEntries;
  ref$ = require('./db'), dbInit = ref$.dbInit, dbUpdate = ref$.dbUpdate, dbDump = ref$.dbDump, getThread = ref$.getThread, getThreadNext = ref$.getThreadNext, getThreadPrev = ref$.getThreadPrev, getThreadLatest = ref$.getThreadLatest, dumpTsv = ref$.dumpTsv;
  process.title = 'deltos';
  commands = {};
  addCommand = function(name, desc, func){
    func.command = name;
    func.desc = desc;
    name = name.split(" ")[0];
    return commands[name] = func;
  };
  addCommand("init", "Set up DELTOS_HOME", function(){
    var mkdirp;
    mkdirp = require('mkdirp');
    mkdirp.sync(deltosHome + 'by-id');
    mkdirp.sync(deltosHome + 'site/by-id');
    return dbInit();
  });
  addCommand("install-theme [git url]", "Install theme", installTheme);
  addCommand("title", "Show title of current deltos", function(){
    return console.log(readConfig().title);
  });
  addCommand("config", "Edit config file", editConfig);
  addCommand("new [title...]", "Create a note and print the filename", function(){
    var args, res$, i$, to$;
    res$ = [];
    for (i$ = 0, to$ = arguments.length; i$ < to$; ++i$) {
      res$.push(arguments[i$]);
    }
    args = res$;
    return console.log(getFilename(newNote(args.join(' '))));
  });
  addCommand("reply [id]", "Reply to a note in a thread", function(id){
    var base, newId;
    base = readEntry(id);
    if (!base.thread) {
      console.log("No thread!");
      process.exit(1);
    }
    newId = newNote(base.title, base.tags, {
      thread: base.thread,
      'reply-to': id
    });
    dbUpdate(newId);
    return console.log(getFilename(newId));
  });
  addCommand("post [title...]", "Start a new post in $EDITOR", function(){
    var args, res$, i$, to$, id, fname;
    res$ = [];
    for (i$ = 0, to$ = arguments.length; i$ < to$; ++i$) {
      res$.push(arguments[i$]);
    }
    args = res$;
    id = newNote(args.join(' '));
    dbUpdate(id);
    fname = getFilename(id);
    return launchEditor(fname, function(){
      return dbUpdate(id);
    });
  });
  addCommand("edit [id]", "Edit an existing post", function(id){
    return launchEditor(getFilename(id), function(){
      return dbUpdate(id);
    });
  });
  addCommand('search', "Interactive search", function(){
    var launchSearch;
    launchSearch = require('./search').launchSearch;
    return launchSearch();
  });
  addCommand("grep [pattern]", "Grep body of notes", function(pat){
    return grepEntries(pat).map(function(it){
      return console.log(it);
    });
  });
  addCommand("philtre [query]", "Philtre notes", function(query){
    return philtreEntries(query).map(function(it){
      return console.log(it);
    });
  });
  addCommand("render [id]", "Render [id] as HTML", function(it){
    var render;
    render = require('./html').render;
    return console.log(render(it));
  });
  addCommand('build-site', "Build static HTML", function(){
    var buildSite;
    buildSite = require('./html').buildSite;
    return buildSite();
  });
  addCommand('clean', "Delete built HTML", function(){
    var fs, dirs, i$, len$, dir, lresult$, j$, ref$, len1$, fname, results$ = [];
    fs = require('fs-extra');
    dirs = [deltosHome + '/site/by-id/'];
    for (i$ = 0, len$ = dirs.length; i$ < len$; ++i$) {
      dir = dirs[i$];
      lresult$ = [];
      for (j$ = 0, len1$ = (ref$ = fs.readdirSync(dir)).length; j$ < len1$; ++j$) {
        fname = ref$[j$];
        lresult$.push(fs.removeSync(dir + fname));
      }
      results$.push(lresult$);
    }
    return results$;
  });
  addCommand('json', "Dump all entries to JSON", function(){
    var dumpJson;
    dumpJson = require('./html').dumpJson;
    return console.log(dumpJson());
  });
  addCommand('todos', "Dump todo list", function(){
    return console.log(dumpTodos());
  });
  addCommand('tsv', "Dump basic TSV", dumpTsv);
  addCommand('db-init', "Init db", function(){
    return dbInit();
  });
  addCommand("db-update [id]", "Update [id]'s db entry", function(it){
    return dbUpdate(it);
  });
  addCommand("db-dump", "Dump db info", function(){
    return dbDump();
  });
  addCommand('version', "Show version number", function(){
    var pkg;
    pkg = require('../package.json');
    return console.log(pkg.version);
  });
  addCommand('help', "Show this help", function(){
    var name, ref$, func, pad;
    console.log("usage: deltos <command> [options...]\n");
    for (name in ref$ = commands) {
      func = ref$[name];
      pad = repeatString$(' ', 25 - func.command.length);
      console.log("    " + func.command + pad + func.desc);
    }
    return process.exit(1);
  });
  addCommand('get-thread', "Get posts in thread", function(name){
    var i$, ref$, len$, entry, results$ = [];
    for (i$ = 0, len$ = (ref$ = getThread(name)).length; i$ < len$; ++i$) {
      entry = ref$[i$];
      results$.push(console.log(entry.id));
    }
    return results$;
  });
  try {
    func = commands[process.argv[2]];
  } catch (e$) {
    e = e$;
    func = commands.help();
  }
  if (!func) {
    func = commands.help;
  }
  func.apply(null, process.argv.slice(3));
  function repeatString$(str, n){
    for (var r = ''; n > 0; (n >>= 1) && (str += str)) if (n & 1) r += str;
    return r;
  }
}).call(this);
